declare
  nUNIT_INTDOCS               PKG_STD.tREF;
  nDMSCLMETHODS_FD            PKG_STD.tREF;
  nDMSCLMETHODS_VW            PKG_STD.tREF;
  nDMSCLACTIONS               PKG_STD.tREF;
  nDMSCLACTIONSPRM            PKG_STD.tREF;
  nDMSCLMETPARMS              PKG_STD.tREF;
  nDMSCLACTIONSMTH            PKG_STD.tREF;
  nDMSCLACTIONSSTP            PKG_STD.tREF;
  cDMSCLACTIONSSTP_SHOWPARAMS clob;
  nUSERFORMS                  PKG_STD.tREF;
  cUSERFORMS_FORMDATA         clob;
begin
  begin
    select T.RN
      into nUNIT_INTDOCS
      from UNITLIST T
     where T.UNITCODE = 'InternalDocuments';
  exception
    when NO_DATA_FOUND then
      p_exception(0,'   "%s".','InternalDocuments');
  end;
  
  cUSERFORMS_FORMDATA := '<?xml version="1.0" encoding="windows-1251" standalone="yes"?>
                          <Object Class="TPDynamicForm"
                                  Name="TPCustomActionContentProvider">
                          	<Left>
                          		<I>594</I>
                          	</Left>
                          	<Top>
                          		<I>191</I>
                          	</Top>
                          	<Width>
                          		<I>481</I>
                          	</Width>
                          	<Height>
                          		<I>241</I>
                          	</Height>
                          	<DesignSize>
                          		<List>
                          			<Item Index="0">
                          				<I>475</I>
                          			</Item>
                          			<Item Index="1">
                          				<I>216</I>
                          			</Item>
                          		</List>
                          	</DesignSize>
                          	<PixelsPerInch>
                          		<I>96</I>
                          	</PixelsPerInch>
                          	<TextHeight>
                          		<I>13</I>
                          	</TextHeight>
                          	<Object Class="TPContentGroupBox"
                          	        Name="ContainerForAutoCreatedControls">
                          		<Left>
                          			<I>8</I>
                          		</Left>
                          		<Top>
                          			<I>7</I>
                          		</Top>
                          		<Width>
                          			<I>459</I>
                          		</Width>
                          		<Height>
                          			<I>168</I>
                          		</Height>
                          		<Anchors>
                          			<Set>
                          				<Item>akLeft</Item>
                          				<Item>akTop</Item>
                          				<Item>akRight</Item>
                          				<Item>akBottom</Item>
                          			</Set>
                          		</Anchors>
                          		<TabOrder>
                          			<I>0</I>
                          		</TabOrder>
                          		<DesignSize>
                          			<List>
                          				<Item Index="0">
                          					<I>455</I>
                          				</Item>
                          				<Item Index="1">
                          					<I>164</I>
                          				</Item>
                          			</List>
                          		</DesignSize>
                          		<ControlId>
                          			<![CDATA[{8593BFD0-431A-480A-AC56-36400B85CB3D}]]>
                          		</ControlId>
                          		<Object Class="TPContentEdit"
                          		        Name="SACCOUNT_PRM">
                          			<Left>
                          				<I>189</I>
                          			</Left>
                          			<Top>
                          				<I>8</I>
                          			</Top>
                          			<Width>
                          				<I>258</I>
                          			</Width>
                          			<Anchors>
                          				<Set>
                          					<Item>akTop</Item>
                          					<Item>akRight</Item>
                          				</Set>
                          			</Anchors>
                          			<ContentDictInterface.Params>
                          				<Collection>
                          					<Item Index="0">
                          						<Name>
                          							<![CDATA[pos_accnumb]]>
                          						</Name>
                          						<ParamTypes>
                          							<Set>
                          								<Item>ptIn</Item>
                          							</Set>
                          						</ParamTypes>
                          						<Control>SACCOUNT_PRM</Control>
                          						<SourceKind>skControl</SourceKind>
                          					</Item>
                          					<Item Index="1">
                          						<Name>
                          							<![CDATA[accnumb]]>
                          						</Name>
                          						<ParamTypes>
                          							<Set>
                          								<Item>ptOut</Item>
                          							</Set>
                          						</ParamTypes>
                          						<Control>SACCOUNT_PRM</Control>
                          						<SourceKind>skControl</SourceKind>
                          					</Item>
                          				</Collection>
                          			</ContentDictInterface.Params>
                          			<ContentDictInterface.DocCode>
                          				<![CDATA[AccountsPlan]]>
                          			</ContentDictInterface.DocCode>
                          			<ContentDictInterface.ShowMethod>
                          				<![CDATA[account]]>
                          			</ContentDictInterface.ShowMethod>
                          			<ControlLabel.Position>
                          				<I>8</I>
                          			</ControlLabel.Position>
                          			<ControlLabel.Text>
                          				<![CDATA[]]>
                          			</ControlLabel.Text>
                          			<MaxLength>
                          				<I>20</I>
                          			</MaxLength>
                          			<TabOrder>
                          				<I>0</I>
                          			</TabOrder>
                          			<ControlId>
                          				<![CDATA[{160814CB-4D82-4E0E-B477-8D4C8CF6C09B}]]>
                          			</ControlId>
                          		</Object>
                          		<Object Class="TPContentEdit"
                          		        Name="SBALUNIT_PRM">
                          			<Left>
                          				<I>189</I>
                          			</Left>
                          			<Top>
                          				<I>33</I>
                          			</Top>
                          			<Width>
                          				<I>258</I>
                          			</Width>
                          			<Anchors>
                          				<Set>
                          					<Item>akTop</Item>
                          					<Item>akRight</Item>
                          				</Set>
                          			</Anchors>
                          			<ContentDictInterface.Params>
                          				<Collection>
                          					<Item Index="0">
                          						<Name>
                          							<![CDATA[pos_mnemo]]>
                          						</Name>
                          						<ParamTypes>
                          							<Set>
                          								<Item>ptIn</Item>
                          							</Set>
                          						</ParamTypes>
                          						<Control>SBALUNIT_PRM</Control>
                          						<SourceKind>skControl</SourceKind>
                          					</Item>
                          					<Item Index="1">
                          						<Name>
                          							<![CDATA[mnemo]]>
                          						</Name>
                          						<ParamTypes>
                          							<Set>
                          								<Item>ptOut</Item>
                          							</Set>
                          						</ParamTypes>
                          						<Control>SBALUNIT_PRM</Control>
                          						<SourceKind>skControl</SourceKind>
                          					</Item>
                          				</Collection>
                          			</ContentDictInterface.Params>
                          			<ContentDictInterface.DocCode>
                          				<![CDATA[BalanceUnits]]>
                          			</ContentDictInterface.DocCode>
                          			<ContentDictInterface.ShowMethod>
                          				<![CDATA[normal]]>
                          			</ContentDictInterface.ShowMethod>
                          			<ControlLabel.Position>
                          				<I>8</I>
                          			</ControlLabel.Position>
                          			<ControlLabel.Text>
                          				<![CDATA[]]>
                          			</ControlLabel.Text>
                          			<MaxLength>
                          				<I>20</I>
                          			</MaxLength>
                          			<TabOrder>
                          				<I>1</I>
                          			</TabOrder>
                          			<ControlId>
                          				<![CDATA[{20389C3D-3E2D-4B83-B577-AE0830BE5630}]]>
                          			</ControlId>
                          		</Object>
                          		<Object Class="TPContentEdit"
                          		        Name="SGROUP_PRM">
                          			<Left>
                          				<I>189</I>
                          			</Left>
                          			<Top>
                          				<I>58</I>
                          			</Top>
                          			<Width>
                          				<I>258</I>
                          			</Width>
                          			<Anchors>
                          				<Set>
                          					<Item>akTop</Item>
                          					<Item>akRight</Item>
                          				</Set>
                          			</Anchors>
                          			<ContentDictInterface.Params>
                          				<Collection>
                          					<Item Index="0">
                          						<Name>
                          							<![CDATA[pos_code]]>
                          						</Name>
                          						<ParamTypes>
                          							<Set>
                          								<Item>ptIn</Item>
                          							</Set>
                          						</ParamTypes>
                          						<Control>SGROUP_PRM</Control>
                          						<SourceKind>skControl</SourceKind>
                          					</Item>
                          					<Item Index="1">
                          						<Name>
                          							<![CDATA[code]]>
                          						</Name>
                          						<ParamTypes>
                          							<Set>
                          								<Item>ptOut</Item>
                          							</Set>
                          						</ParamTypes>
                          						<Control>SGROUP_PRM</Control>
                          						<SourceKind>skControl</SourceKind>
                          					</Item>
                          				</Collection>
                          			</ContentDictInterface.Params>
                          			<ContentDictInterface.DocCode>
                          				<![CDATA[GroupMaterials]]>
                          			</ContentDictInterface.DocCode>
                          			<ContentDictInterface.ShowMethod>
                          				<![CDATA[normal]]>
                          			</ContentDictInterface.ShowMethod>
                          			<ControlLabel.Position>
                          				<I>8</I>
                          			</ControlLabel.Position>
                          			<ControlLabel.Text>
                          				<![CDATA[ ]]>
                          			</ControlLabel.Text>
                          			<MaxLength>
                          				<I>20</I>
                          			</MaxLength>
                          			<TabOrder>
                          				<I>2</I>
                          			</TabOrder>
                          			<ControlId>
                          				<![CDATA[{693F9D93-08AC-4A85-9982-8794DB895ADF}]]>
                          			</ControlId>
                          		</Object>
                          		<Object Class="TPContentEdit"
                          		        Name="SNOMENCODE_PRM">
                          			<Left>
                          				<I>189</I>
                          			</Left>
                          			<Top>
                          				<I>83</I>
                          			</Top>
                          			<Width>
                          				<I>258</I>
                          			</Width>
                          			<Anchors>
                          				<Set>
                          					<Item>akTop</Item>
                          					<Item>akRight</Item>
                          				</Set>
                          			</Anchors>
                          			<ContentDictInterface.Params>
                          				<Collection>
                          					<Item Index="0">
                          						<Name>
                          							<![CDATA[pos_nomcode]]>
                          						</Name>
                          						<ParamTypes>
                          							<Set>
                          								<Item>ptIn</Item>
                          							</Set>
                          						</ParamTypes>
                          						<Control>SNOMENCODE_PRM</Control>
                          						<SourceKind>skControl</SourceKind>
                          					</Item>
                          					<Item Index="1">
                          						<Name>
                          							<![CDATA[nomcode]]>
                          						</Name>
                          						<ParamTypes>
                          							<Set>
                          								<Item>ptOut</Item>
                          							</Set>
                          						</ParamTypes>
                          						<Control>SNOMENCODE_PRM</Control>
                          						<SourceKind>skControl</SourceKind>
                          					</Item>
                          				</Collection>
                          			</ContentDictInterface.Params>
                          			<ContentDictInterface.DocCode>
                          				<![CDATA[Nomenclator]]>
                          			</ContentDictInterface.DocCode>
                          			<ContentDictInterface.ShowMethod>
                          				<![CDATA[normal]]>
                          			</ContentDictInterface.ShowMethod>
                          			<ControlLabel.Position>
                          				<I>8</I>
                          			</ControlLabel.Position>
                          			<ControlLabel.Text>
                          				<![CDATA[. ]]>
                          			</ControlLabel.Text>
                          			<MaxLength>
                          				<I>160</I>
                          			</MaxLength>
                          			<TabOrder>
                          				<I>3</I>
                          			</TabOrder>
                          			<ControlId>
                          				<![CDATA[{8F7448CE-C7C2-4923-A05F-33612A196461}]]>
                          			</ControlId>
                          		</Object>
                          		<Object Class="TPContentEdit"
                          		        Name="SNOMENNAME_PRM">
                          			<Left>
                          				<I>189</I>
                          			</Left>
                          			<Top>
                          				<I>108</I>
                          			</Top>
                          			<Width>
                          				<I>258</I>
                          			</Width>
                          			<Anchors>
                          				<Set>
                          					<Item>akTop</Item>
                          					<Item>akRight</Item>
                          				</Set>
                          			</Anchors>
                          			<ContentDictInterface.Params>
                          				<Collection>
                          					<Item Index="0">
                          						<Name>
                          							<![CDATA[pos_nomname]]>
                          						</Name>
                          						<ParamTypes>
                          							<Set>
                          								<Item>ptIn</Item>
                          							</Set>
                          						</ParamTypes>
                          						<Control>SNOMENNAME_PRM</Control>
                          						<SourceKind>skControl</SourceKind>
                          					</Item>
                          					<Item Index="1">
                          						<Name>
                          							<![CDATA[nomname]]>
                          						</Name>
                          						<ParamTypes>
                          							<Set>
                          								<Item>ptOut</Item>
                          							</Set>
                          						</ParamTypes>
                          						<Control>SNOMENNAME_PRM</Control>
                          						<SourceKind>skControl</SourceKind>
                          					</Item>
                          				</Collection>
                          			</ContentDictInterface.Params>
                          			<ContentDictInterface.DocCode>
                          				<![CDATA[Nomenclator]]>
                          			</ContentDictInterface.DocCode>
                          			<ContentDictInterface.ShowMethod>
                          				<![CDATA[normal]]>
                          			</ContentDictInterface.ShowMethod>
                          			<ControlLabel.Position>
                          				<I>8</I>
                          			</ControlLabel.Position>
                          			<ControlLabel.Text>
                          				<![CDATA[. ]]>
                          			</ControlLabel.Text>
                          			<MaxLength>
                          				<I>240</I>
                          			</MaxLength>
                          			<TabOrder>
                          				<I>4</I>
                          			</TabOrder>
                          			<ControlId>
                          				<![CDATA[{9330F6F4-2F81-42DE-9569-C4985AA04F20}]]>
                          			</ControlId>
                          		</Object>
                          	</Object>
                          	<Object Class="TPContentCancelButton"
                          	        Name="CancelButton">
                          		<Left>
                          			<I>377</I>
                          		</Left>
                          		<Top>
                          			<I>183</I>
                          		</Top>
                          		<Width>
                          			<I>90</I>
                          		</Width>
                          		<Anchors>
                          			<Set>
                          				<Item>akRight</Item>
                          				<Item>akBottom</Item>
                          			</Set>
                          		</Anchors>
                          		<TabOrder>
                          			<I>2</I>
                          		</TabOrder>
                          	</Object>
                          	<Object Class="TPContentOkButton"
                          	        Name="OKButton">
                          		<Left>
                          			<I>282</I>
                          		</Left>
                          		<Top>
                          			<I>183</I>
                          		</Top>
                          		<Width>
                          			<I>90</I>
                          		</Width>
                          		<Anchors>
                          			<Set>
                          				<Item>akRight</Item>
                          				<Item>akBottom</Item>
                          			</Set>
                          		</Anchors>
                          		<TabOrder>
                          			<I>1</I>
                          		</TabOrder>
                          	</Object>
                          	<Object Class="TPContentUserConditions"
                          	        Name="AutoCreatedUserConditions">
                          		<Conditions>
                          			<![CDATA[<?xml version="1.0" encoding="windows-1251" standalone="yes"?><control-rules/>]]>
                          		</Conditions>
                          	</Object>
                          </Object>';
  
  --  P_INTDOCS_FORMDATAYP
  P_DMSCLMETHODS_INSERT(nUNIT_INTDOCS,0,'P_INTDOCS_FORMDATAYP',null,'P_INTDOCS_FORMDATAYP','P_INTDOCS_FORMDATAYP',1,null,null,nDMSCLMETHODS_FD);
  -- 
  P_DMSCLACTIONS_INSERT(nUNIT_INTDOCS,null,'INTDOCS_HFORMDATAYP','  ',6011,0,null,0,'P_INTDOCS_FORMDATAYP',1,1,1,0,null,0,nDMSCLACTIONS);
  --  
  P_DMSCLACTIONSPRM_INSERT(nDMSCLACTIONS,'TRN','NIDENT',1,null,null,null,null,0,null,null,null,nDMSCLACTIONSPRM);
  P_DMSCLACTIONSPRM_INSERT(nDMSCLACTIONS,'CODE20','EXECUTEMETHOD',2,'P_INTDOCS_FORMDATAYP',null,null,null,3,null,null,null,nDMSCLACTIONSPRM);
  P_DMSCLACTIONSPRM_INSERT(nDMSCLACTIONS,'TRN','NEXT_STEP',3,null,0,null,null,3,null,null,null,nDMSCLACTIONSPRM);
  
  --   P_INTDOCS_FORMDATAYP
  P_DMSCLMETPARMS_INSERT(nDMSCLMETHODS_FD,'TRN','NPRN','NPRN',1,1,null,null,null,null,2,0,null,1,null,null,nDMSCLMETPARMS);
  P_DMSCLMETPARMS_INSERT(nDMSCLMETHODS_FD,'CODE20','SACCOUNT_PRM','',2,1,null,null,null,null,0,null,null,0,null,null,nDMSCLMETPARMS);
  P_DMSCLMETPARMS_INSERT(nDMSCLMETHODS_FD,'CODE20','SBALUNIT_PRM','',3,1,null,null,null,null,0,null,null,0,null,null,nDMSCLMETPARMS);
  P_DMSCLMETPARMS_INSERT(nDMSCLMETHODS_FD,'CODE160','SNOMENCODE_PRM','. ',4,1,null,null,null,null,0,null,null,0,null,null,nDMSCLMETPARMS);
  P_DMSCLMETPARMS_INSERT(nDMSCLMETHODS_FD,'CODE240','SNOMENNAME_PRM','. ',5,1,null,null,null,null,0,null,null,0,null,null,nDMSCLMETPARMS);
  P_DMSCLMETPARMS_INSERT(nDMSCLMETHODS_FD,'TRN','NCOMPANY','NCOMPANY',6,1,null,null,null,null,2,3,null,1,null,null,nDMSCLMETPARMS);
  P_DMSCLMETPARMS_INSERT(nDMSCLMETHODS_FD,'TRN','NIDENT','NIDENT',7,2,null,null,null,null,5,null,null,0,'NIDENT',null,nDMSCLMETPARMS);
  P_DMSCLMETPARMS_INSERT(nDMSCLMETHODS_FD,'CODE20','SEXECUTEMETHOD','SEXECUTEMETHOD',8,2,null,null,null,null,5,null,null,0,'EXECUTEMETHOD',null,nDMSCLMETPARMS);
  P_DMSCLMETPARMS_INSERT(nDMSCLMETHODS_FD,'CODE20','SGROUP_PRM',' ',9,1,null,null,null,null,0,null,null,0,null,null,nDMSCLMETPARMS);

  --  P_INTDOCS_RELOADVIEW
  P_DMSCLMETHODS_INSERT(nUNIT_INTDOCS,0,'P_INTDOCS_RELOADVIEW',null,'P_INTDOCS_RELOADVIEW','P_INTDOCS_RELOADVIEW',1,null,null,nDMSCLMETHODS_VW);
  --   P_INTDOCS_RELOADVIEW
  P_DMSCLMETPARMS_INSERT(nDMSCLMETHODS_VW,'TRN','NRN','NRN',1,1,null,null,null,null,2,0,null,1,null,null,nDMSCLMETPARMS);
  P_DMSCLMETPARMS_INSERT(nDMSCLMETHODS_VW,'TRN','NCOMPANY','NCOMPANY',2,1,null,null,null,null,2,3,null,1,null,null,nDMSCLMETPARMS);
  
  --  
  P_DMSCLACTIONSMTH_INSERT(nDMSCLACTIONS,'P_INTDOCS_FORMDATAYP',nDMSCLACTIONSMTH);
  
  --   
  nUSERFORMS := null;
  P_USERFORMS_INSERT(3,'InternalDocuments',null,nDMSCLACTIONSMTH,' :   ',' :   ',0,0,1,null,null,nUSERFORMS);
  
  update USERFORMS u
     set u.form_data = cUSERFORMS_FORMDATA
   where u.rn = nUSERFORMS;
  --
  
  P_DMSCLACTIONSMTH_INSERT(nDMSCLACTIONS,'P_INTDOCS_RELOADVIEW',nDMSCLACTIONSMTH);
  
  --  
  P_DMSCLACTIONSSTP_INSERT(nDMSCLACTIONS,1,0,null,null,0,null,'NIDENT',nDMSCLACTIONSSTP);
  
  cDMSCLACTIONSSTP_SHOWPARAMS := '<?xml version="1.0" encoding="windows-1251" standalone="yes"?>
                                 <Params UnitCode="USERMET">
                                 	<Param Name="in_IDENT" OutParam="0">
                                 		<ActionParam>NIDENT</ActionParam>
                                 	</Param>
                                </Params>';
  
  P_DMSCLACTIONSSTP_INSERT(nDMSCLACTIONS,2,1,'.    ','USERMET',2,cDMSCLACTIONSSTP_SHOWPARAMS,'NIDENT',nDMSCLACTIONSSTP);
  P_DMSCLACTIONSSTP_INSERT(nDMSCLACTIONS,3,0,null,null,0,null,null,nDMSCLACTIONSSTP);

  --  
  nUSERFORMS := null;
  P_USERFORMS_INSERT(3,'InternalDocuments',null,nDMSCLACTIONS,' :   ',' :   ',0,0,1,null,null,nUSERFORMS);
  
  update USERFORMS u
     set u.form_data = cUSERFORMS_FORMDATA
   where u.rn = nUSERFORMS;
  --

  
end;